var
  _ = require('underscore'),
  Promise = require('es6-promise').Promise;

/**
 * DispatchHandler
 */
function DispatchHandler(listeners){
  this._listeners = listeners;
}
DispatchHandler.prototype.dispatch = function(event_name, payload){
  var promises = [];
  _.each(this._listeners, function(store){
    var fn = store[event_name];
    if (typeof(fn) === 'function') {
      promises.push(fn.call(store, payload));
    }
  });
  return Promise.all(promises);
};

exports.DispatchHandler = DispatchHandler;